/*
 * Copyright (C) 2003, Ki-young Choi, k.choi@physics.hanyang.ac.kr
 */

#include <stdio.h>
#include <gsl/gsl_const_mks.h>
#include "gfdtd.h"
#include "TCanvas.h"
#include "TDirectory.h"
#include "TH2D.h"
#include "TStyle.h"


int main(void)
{
	FILE *fpt1;
	int iteration,i,j;
	int MAXTIMESTEP;
	int X_SIZE, Y_SIZE, PML_DEPTH;
	double FREQ;
	double dT;
	char filename[256];
	char mode[3];


	/* Def. of System */
	Fields fields;
	Coef coef;

	/* init fields */
	init(&fields, &coef, &MAXTIMESTEP, &X_SIZE, &Y_SIZE, &PML_DEPTH, &FREQ, &dT, mode);
	/* calculate fields */
	printf("= Calculation start..\n\n");
	while(FREQ==1227000000000000.0)
	{
		for(iteration = 0 ; iteration<MAXTIMESTEP ; iteration++)
		{
			update_fields(&fields, &coef, iteration, X_SIZE, Y_SIZE, PML_DEPTH, FREQ, dT, mode);
			if(iteration%5==0 )
			{
				sprintf(filename,"pictures/%d.pic",iteration);
				fpt1 = fopen(filename, "w");
				for(i=0;i<1000;i++)
				{
					for(j=0;j<1000;j++)
						fprintf(fpt1,"%f\t",fields.Ez(i,j));
					fprintf(fpt1,"\n");
				}
				fclose(fpt1);
			}

		}
		FREQ = FREQ + 1000000000000.0;
		clear_fields(&fields,mode);
	}
	return 1;
}
